Package com.io7m.waxmill.machines

# Interface WXMDeviceType

All Known Subinterfaces:
  `WXMDeviceType.WXMDeviceAHCIDiskType`, `WXMDeviceType.WXMDeviceAHCIOpticalDiskType`, `WXMDeviceType.WXMDeviceE1000Type`, `WXMDeviceType.WXMDeviceFramebufferType`, `WXMDeviceType.WXMDeviceHostBridgeType`, `WXMDeviceType.WXMDeviceLPCType`, `WXMDeviceType.WXMDevicePassthruType`, `WXMDeviceType.WXMDeviceVirtioBlockStorageType`, `WXMDeviceType.WXMDeviceVirtioNetworkType`

All Known Implementing Classes:
  `WXMDeviceAHCIDisk`, `WXMDeviceAHCIOpticalDisk`, `WXMDeviceE1000`, `WXMDeviceFramebuffer`, `WXMDeviceHostBridge`, `WXMDeviceLPC`, `WXMDevicePassthru`, `WXMDeviceVirtioBlockStorage`, `WXMDeviceVirtioNetwork`

    public interface WXMDeviceType

The type of devices that can be attached to virtual machines.

- ## Nested Class Summary

  Nested Classes
  Modifier and Type | Interface | Description
  --- | --- | ---
  `static class` | `WXMDeviceType.Kind` | The device kind
  `static interface` | `WXMDeviceType.WXMDeviceAHCIDiskType` |
  `static interface` | `WXMDeviceType.WXMDeviceAHCIOpticalDiskType` |
  `static interface` | `WXMDeviceType.WXMDeviceE1000Type` | An emulation of an Intel e82545 network device.
  `static interface` | `WXMDeviceType.WXMDeviceFramebufferType` | A raw framebuffer device attached to a VNC server.
  `static interface` | `WXMDeviceType.WXMDeviceHostBridgeType` |
  `static interface` | `WXMDeviceType.WXMDeviceLPCType` |
  `static interface` | `WXMDeviceType.WXMDevicePassthruType` | A PCI passthru device.
  `static interface` | `WXMDeviceType.WXMDeviceVirtioBlockStorageType` |
  `static interface` | `WXMDeviceType.WXMDeviceVirtioNetworkType` |
  `static class` | `WXMDeviceType.WXMLPCTTYNames` |
  `static interface` | `WXMDeviceType.WXMNetworkDeviceBackendType` | The type of network device backends.
  `static interface` | `WXMDeviceType.WXMSectorSizesType` |
  `static interface` | `WXMDeviceType.WXMStorageBackendFileType` |
  `static interface` | `WXMDeviceType.WXMStorageBackendType` |
  `static interface` | `WXMDeviceType.WXMStorageBackendZFSVolumeType` |
  `static interface` | `WXMDeviceType.WXMTapType` | A TAP device.
  `static interface` | `WXMDeviceType.WXMTTYBackendFileType` |
  `static interface` | `WXMDeviceType.WXMTTYBackendNMDMType` |
  `static interface` | `WXMDeviceType.WXMTTYBackendStdioType` |
  `static interface` | `WXMDeviceType.WXMTTYBackendType` |
  `static interface` | `WXMDeviceType.WXMVMNetType` | A vmnet device.

- ## Method Summary

  Modifier and Type | Method | Description
  --- | --- | ---
  `java.lang.String` | `comment()` |
  `WXMDeviceSlot` | `deviceSlot()` |
  `java.lang.String` | `externalName()` |
  `default boolean` | `isConsoleDevice()` |
  `default boolean` | `isStorageDevice()` |
  `WXMDeviceType.Kind` | `kind()` |

- ## Method Details

  - ### deviceSlot

    WXMDeviceSlot deviceSlot()
    Returns:
      The device slot

  - ### kind

    WXMDeviceType.Kind kind()
    Returns:
      The device kind

  - ### externalName

    java.lang.String externalName()
    Returns:
      The external name of the type (such as `ahci-cd`).

  - ### comment

    java.lang.String comment()
    Returns:
      A descriptive comment

  - ### isStorageDevice

    default boolean isStorageDevice()
    Returns:
      `true` if this device is a storage device

  - ### isConsoleDevice

    default boolean isConsoleDevice()
    Returns:
      `true` if this device is a console/tty device